%define major		0.10
%define libname		%mklibname jxl %{major}
%define libnamecms	%mklibname jxl_cms %{major}
%define libnamecodec	%mklibname jxl_extras_codec %{major}
%define libnamethreads	%mklibname jxl_threads %{major}
%define develname	%mklibname jxl -d

# bundled skcms (only needed if we enables plugin for GdkPixbuf image loading library)
%define skcms_commit	42030a771244ba67f86b1c1c76a6493f873c5f91

%bcond_with gimp_plugin
%bcond_without gdk_pixbuf
%bcond_without tcmalloc

Name:		libjxl
Version:	0.10.4
Release:	%mkrel 2
Summary:	JPEG XL reference implementation
License:	BSD
Group:		System/Libraries
URL:		https://jpegxl.info/
#Git-Clone:     https://github.com/libjxl/libjxl
Source0:	https://github.com/libjxl/libjxl/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:	https://skia.googlesource.com/skcms/+archive/%{skcms_commit}.tar.gz

BuildRequires:	asciidoc
BuildRequires:	cmake
BuildRequires:	doxygen
BuildRequires:	python3dist(sphinx)
BuildRequires:	giflib-devel
BuildRequires:	pkgconfig(gflags)
BuildRequires:	pkgconfig(gmock)
BuildRequires:	pkgconfig(lcms2)
BuildRequires:	pkgconfig(libavif)
BuildRequires:	pkgconfig(libbrotlicommon)
BuildRequires:	pkgconfig(libbrotlidec)
BuildRequires:	pkgconfig(libbrotlienc)
BuildRequires:	pkgconfig(libhwy) >= 1.0
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libwebp)
BuildRequires:	pkgconfig(OpenEXR)
BuildRequires:	pkgconfig(zlib)
%if %{with tcmalloc}
BuildRequires:	pkgconfig(libtcmalloc)
%endif
%if %{with gimp_plugin}
BuildRequires:	pkgconfig(gimp-2.0)
%endif
%if %{with gdk_pixbuf}
BuildRequires:	pkgconfig(gdk-pixbuf-2.0)
%endif

%description
JPEG XL is a raster-graphics file format that supports both lossy and
lossless compression.

This is the reference implementation of JPEG XL, with encoder and decoder.

#------------------------------------------------

%package -n	%{libname}
Summary:	Library for encoding and decoding JPEG XL raster graphic images
Group:		System/Libraries

%description -n	%{libname}
JPEG XL is a raster-graphics file format that supports both lossy and
lossless compression.

#------------------------------------------------

%package -n	%{libnamecms}
Summary:	Library for encoding and decoding JPEG XL raster graphic images
Group:		System/Libraries

%description -n	%{libnamecms}
JPEG XL is a raster-graphics file format that supports both lossy and
lossless compression.

#------------------------------------------------

%package -n	%{libnamecodec}
Summary:	Library for encoding and decoding JPEG XL raster graphic images
Group:		System/Libraries

%description -n	%{libnamecodec}
JPEG XL is a raster-graphics file format that supports both lossy and
lossless compression.

#------------------------------------------------

%package -n	%{libnamethreads}
Summary:	Library for encoding and decoding JPEG XL raster graphic images
Group:		System/Libraries

%description -n	%{libnamethreads}
JPEG XL is a raster-graphics file format that supports both lossy and
lossless compression.

#------------------------------------------------

%package -n	%{develname}
Summary:	Development package for %{name}
Group:		Development/C++
Requires:	%{libname} = %{version}-%{release}
Requires:	%{libnamecms} = %{version}-%{release}
Requires:	%{libnamecodec} = %{version}-%{release}
Requires:	%{libnamethreads} = %{version}-%{release}
Provides:	jxl-devel = %{version}-%{release}

%description -n	%{develname}
Header files for development with %{name}.

#------------------------------------------------

%package	tools
Summary:	Command-line utilities to convert from/to JPEG XL
Group:		Development/Tools

%description	tools
Command-line utilities to convert from/to JPEG XL.

#------------------------------------------------
%if %{with gimp_plugin}

%package -n	gimp-plugin-jxl
Summary:	A plugin for loading and saving JPEG-XL images
Group:		Graphics/Editors and Converters
Requires:	gimp

%description -n	gimp-plugin-jxl
This is a GIMP plugin for loading and saving JPEG-XL images.
%endif

#------------------------------------------------
%if %{with gdk_pixbuf}

%package -n	jxl-pixbuf-loader
Summary:	JPEG-XL image loader for GTK+ applications
Group:		System/Libraries
Requires:	gdk-pixbuf2.0

%description -n	jxl-pixbuf-loader
Jxl-pixbuf-loader contains a plugin to load JPEG-XL images
in GTK+ applications.
%endif

#------------------------------------------------

%prep
%autosetup -p1

cd third_party/skcms && tar xf %{S:1}

%build
%ifarch armv7hl
export CXXFLAGS="%{optflags} -DHWY_COMPILE_ONLY_EMU128"
%endif

%cmake  -DJPEGXL_FORCE_SYSTEM_HWY=ON \
%ifarch armv7hl
	-DHWY_CMAKE_ARM7=ON \
%endif
	-DJPEGXL_FORCE_SYSTEM_BROTLI=ON \
	-DJPEGXL_FORCE_SYSTEM_LCMS2=ON \
	-DJPEGXL_FORCE_SYSTEM_GTEST=ON \
	-DBUILD_TESTING=OFF \
	-DJPEGXL_ENABLE_PLUGINS=ON \
%if ! %{with gimp_plugin}
	-DJPEGXL_ENABLE_PLUGIN_GIMP210=OFF \
%endif
%if ! %{with gdk_pixbuf}
	-DJPEGXL_ENABLE_PLUGIN_GDKPIXBUF=OFF \
	-DJPEGXL_ENABLE_SKCMS=OFF \
%endif
	-DJPEGXL_ENABLE_SJPEG=OFF \
	-DJPEGXL_STATIC=OFF \
	-DBUNDLE_LIBPNG_DEFAULT=OFF

%cmake_build -- all doc

%install
%cmake_install

# we don't want these
find %{buildroot} -name '*.a' -delete

%files -n %{libname}
%license LICENSE
%{_libdir}/libjxl.so.%{major}{,.*}

%files -n %{libnamecms}
%license LICENSE
%{_libdir}/libjxl_cms.so.%{major}{,.*}

%files -n %{libnamecodec}
%license LICENSE
%{_libdir}/libjxl_extras_codec.so.%{major}{,.*}

%files -n %{libnamethreads}
%license LICENSE
%{_libdir}/libjxl_threads.so.%{major}{,.*}

%files -n %{develname}
%doc CONTRIBUTING.md CONTRIBUTORS README.md
%{_includedir}/jxl/
%{_libdir}/libjxl.so
%{_libdir}/libjxl_cms.so
%{_libdir}/libjxl_extras_codec.so
%{_libdir}/libjxl_threads.so
%{_libdir}/pkgconfig/*.pc

%files tools
%doc CONTRIBUTING.md CONTRIBUTORS README.md
%doc %{_vpath_builddir}/html
%{_bindir}/*xl*
%{_mandir}/man1/*xl*.1.*
%{_datadir}/mime/packages/image-jxl.xml

%if %{with gimp_plugin}
%files -n gimp-plugin-jxl
%license LICENSE
%{_libdir}/gimp/2.0/plug-ins/file-jxl/
%endif

%if %{with gdk_pixbuf}
%files -n jxl-pixbuf-loader
%license LICENSE
%{_libdir}/gdk-pixbuf-2.0/*/loaders/libpixbufloader-jxl.so
%{_datadir}/thumbnailers/jxl.thumbnailer
%endif


%changelog
* Tue Apr 01 2025 papoteur <papoteur> 0.10.4-2.mga10
+ Revision: 2172500
- rebuild without gimp, now 3.0

* Fri Jan 10 2025 ns80 <ns80> 0.10.4-1.mga10
+ Revision: 2136975
- new version 0.10.4 for CVE-2024-11403 and CVE-2024-11498 (mga#33818)

* Fri Jul 05 2024 daviddavid <daviddavid> 0.10.3-1.mga10
+ Revision: 2079909
- new version: 0.10.3
- now libmajor is 0.10

* Wed Nov 08 2023 daviddavid <daviddavid> 0.8.2-2.mga10
+ Revision: 2005120
- rebuild for new libavif 1.0.1

* Tue Nov 07 2023 daviddavid <daviddavid> 0.8.2-1.mga10
+ Revision: 2005028
- new version: 0.8.2
- now libmajor is 0.8
- enable plugin for GdkPixbuf image loading library

* Sun Feb 05 2023 daviddavid <daviddavid> 0.7.0-6.mga9
+ Revision: 1938613
- enable jpegxl gimp plugin
- enable html docs and manpages support
- enable tcmalloc support
- use system gtest/gmock

* Wed Nov 30 2022 pterjan <pterjan> 0.7.0-5.mga9
+ Revision: 1913529
- One more attempt at fixing armv7hl

* Mon Nov 28 2022 kekepower <kekepower> 0.7.0-4.mga9
+ Revision: 1912182
- Bump rel
- Another try at fixing the build on arm

* Mon Nov 28 2022 pterjan <pterjan> 0.7.0-3.mga9
+ Revision: 1912176
- Try to fix build on armv7hl

* Fri Nov 18 2022 daviddavid <daviddavid> 0.7.0-2.mga9
+ Revision: 1908617
- add some build requirements
- exclude armv7 arch for now

* Fri Nov 18 2022 daviddavid <daviddavid> 0.7.0-1.mga9
+ Revision: 1908611
- initial package libjxl

